<?php
error_reporting(E_ALL);
ini_set('display_errors', 0);
/**
 * Plugin Name: Shopstato
 * Plugin URI: https://blog.shopstato.com/rady-navody/plugin-k-napojeni-woocommerce/
 * Description: Plugin na propojení se službou Shopstato.com
 * Version: 1.2.1
 * Author: shopstato.com
 * Author URI: https://www.shopstato.com/
 * Requires at least: 5.0
 * Tested up to: 5.2
 *
 */

if (!defined('Shopstato_PLUGIN_FILE')) {
    define('Shopstato_PLUGIN_FILE', __FILE__);
    define('Shopstato_PLUGIN_DIR', __DIR__);
}


if (!defined('Shopstato_PLUGIN_URL')) {
    define('Shopstato_PLUGIN_URL', plugins_url('', __FILE__) . '/');
}

include_once(Shopstato_PLUGIN_DIR . '/class.shopstato.php');

define('Shopstato_PLUGIN_VERSION', '1.2.1');


add_action('admin_menu', 'shopstato_menu');
if (!function_exists('shopstato_menu')) {
    function shopstato_menu()
    {
        add_menu_page(
            'Shopstato.com',
            'Shopstato.com',
            'manage_options',
            'shopstato',
            'shopstato_config',
            '',
            6
        );
    }
}

function shopstato_config()
{
?>
    <h1> <?php esc_html_e('Shopstato.com', 'header'); ?> </h1>
    <form method="POST" action="options.php">
        <?php
        settings_fields('config-shopstato');
        do_settings_sections('config-shopstato');
        submit_button();
        ?>
    </form>
    <?php
}


add_action('admin_menu', 'shopstato_menu_news');
if (!function_exists('shopstato_menu_news')) {
    function shopstato_menu_news()
    {
        add_submenu_page(
            'shopstato',
            'Novinky',
            'Novinky',
            'manage_options',
            'shopstato_news',
            'shopstato_news'
        );
    }
}

if (!function_exists('shopstato_news')) {
    function shopstato_news()
    {
    ?> <div class="dashboard-widgets-wrap">
            <h1>Novinky v Shopstato.com</h1>
            <?php
            $data = file_get_contents("https://shopstato.com/news.json");
            $json = json_decode($data, true);

            foreach ($json as $item) {
            ?>
                <div class="postbox">

                    <div class="inside">
                        <h3 class="hndle ui-sortable-handle"><?php echo $item['title'] ?>
                        </h3>
                        <div class="event-info">
                            <?php echo $item['describe'] ?>
                        </div>
                        <hr>
                        <div class="event-date-time"> <span class="event-date">datum: <?php echo $item['date'] ?></span></div>


                    </div>
                </div>
            <?php
            }
            ?>
        </div>
    <?php
    }
}

add_action('admin_menu', 'shopstato_menu_logs');
if (!function_exists('shopstato_menu_logs')) {
    function shopstato_menu_logs()
    {
        add_submenu_page(
            'shopstato',
            'Logy',
            'Logy',
            'manage_options',
            'shopstato_logs',
            'shopstato_logs'
        );
    }
}

if (!function_exists('shopstato_logs')) {
    function shopstato_logs()
    {
    ?> <div class="dashboard-widgets-wrap">
            <h1>Logy z přenosu dat</h1>

            <div class="postbox">

                <div class="inside">
                    <h3 class="hndle ui-sortable-handle">Objednávka
                    </h3>
                    <div class="activity-block">
                        <ul >
                        <?php foreach (get_option('shopstatoImportOrder') as $key => $value) {
                           if(!is_array($value)) {
                            echo '<li>'.ucwords($key) . ': ' . $value . '</li>';
                           }
                           else {
                               echo '<li>'.$key.'<br><ul>';
                               foreach($value as $k=>$v) {
                                echo '<li> - '.ucwords($k) . ': ' . $v . '</li>';
                               }
                               echo '</ul></li>';
                           }
                        }  ?>
                        </ul>
                    </div>

                </div>
            </div>

        </div>
        <div class="dashboard-widgets-wrap">
           

            <div class="postbox">

                <div class="inside">
                    <h3 class="hndle ui-sortable-handle">Sklad
                    </h3>
                    <div class="event-info">
                        <ul>
                        <?php foreach (get_option('shopstatoImportStock') as $key => $value) {
                           if(!is_array($value)) {
                            echo '<li>'.ucwords($key) . ': ' . $value . '</li>';
                           }
                           else {
                               echo '<li>'.$key.'<br><ul>';
                               foreach($value as $k=>$v) {
                                echo '<li> - '.ucwords($k) . ': ' . $v . '</li>';
                               }
                               echo '</ul></li>';
                           }
                        }  ?>
                        </ul>

                    </div>

                </div>
            </div>

        </div>
    <?php
    }
}


add_action('admin_init', 'setting_init');

function setting_init()
{

    add_settings_section(
        'setting_section',
        __('Nastavení', 'config-text'),
        'shopstato_setting_section_callback_function',
        'config-shopstato'
    );



    add_settings_field(
        'url',
        __('Konfigurace', 'config-text'),
        'shopstato_setting_markup',
        'config-shopstato',
        'setting_section'
    );
    register_setting('config-shopstato', 'shopstatoUrl');
    register_setting('config-shopstato', 'shopstatoToken');
    register_setting('config-shopstato', 'shopstatoOldOrders');

    add_settings_field(
        'cron',
        __('Cron', 'config-text'),
        'shopstato_setting_cron',
        'config-shopstato',
        'setting_cron'
    );

    add_settings_section(
        'setting_cron',
        '',
        '',
        'config-shopstato'
    );
}


function shopstato_setting_section_callback_function()
{
    echo '<p>Produkční přístupové údaje získte v administraci <a href="https://cz.shopstato.com" target="_blank">cz.shopstato.com</a></p>';
    echo '<p>Testovací přístupové údaje získte v administraci <a href="https://demo.shopstato.com" target="_blank">demo.shopstato.com</a></p>';
}


function shopstato_setting_markup()
{
    ?>
    <label for="my-input"><?php _e('URL API'); ?></label>
    <input type="text" id="shopstatoUrl" name="shopstatoUrl" value="<?php echo get_option('shopstatoUrl'); ?>"><br>
    <label for="my-input"><?php _e('TOKEN'); ?></label>
    <input type="text" id="shopstatoToken" name="shopstatoToken" value="<?php echo get_option('shopstatoToken'); ?>">
    <?php

    if (intval(get_option('shopstatoOldOrders')) == 0) { ?>
        <br>
        <label for="my-input">Pokud chcete zpětně naimportovat objednávky (max 3měsíce zpět, nebo 1200 objednávek) potvrďte volbu</label>
        <input type="checkbox" id="shopstatoOldOrders" name="shopstatoOldOrders" value="-1" <?php intval(get_option('shopstatoOldOrders')) == 1 ? 'checkbed="checked"' : ''; ?>>
    <?php
    }
    if (intval(get_option('shopstatoOldOrders')) == -1) {

    ?>
        <br>
        <a target="_blank" href="<?= Shopstato_PLUGIN_URL ?>import.php">chci spusti zpětný import</a>
    <?php
    }
    if (!empty(get_option('shopstatoUrl')) && !empty(get_option('shopstatoToken'))) {
        $shopstato = new ShopsatoConnector(get_option('shopstatoUrl'), get_option('shopstatoToken'));
        $shopstato->getStatus();
    }
}


function shopstato_setting_cron()
{
    ?>

    Aby aktualizace skladových zásob neměla negativní vliv na chod Vašeho eshopu, nastavte cron aby se spouštěl 1x za 7 dní , kdy na webu máte nejnižší návštěvnost.<br>
    Adresa pro aktualizaci skladových zásob. Tuto adresu si nastavte jako cron na Vašem hostingu.<br><br>
    <strong>
        <?php
        $shopstato = new ShopsatoConnector(get_option('shopstatoUrl'), get_option('shopstatoToken'));
        echo plugin_dir_url(Shopstato_PLUGIN_FILE) . 'storage.php?hash=' . $shopstato->getHash();

        ?>
    </strong>
<?php
}



add_action('woocommerce_thankyou', 'sendToApi', 10, 1);
if (is_admin()) {
    add_action('woocommerce_order_status_changed', 'sendToApi');
    add_action('woocommerce_saved_order_items', 'sendToApi');
}

function sendToApi($order_id)
{
    if (!empty(get_option('shopstatoUrl')) && !empty(get_option('shopstatoToken'))) {
        $shopstato = new ShopsatoConnector(get_option('shopstatoUrl'), get_option('shopstatoToken'));
        $orders[] = $shopstato->getOrderData($order_id);
        $jsonData = json_encode($orders);
        $response = $shopstato->connect('orders', $jsonData);
        update_option('shopstatoImportOrder', $response);
    }
}
